#ifndef __LINUX_AUDIT_HOOKS_H
#define __LINUX_AUDIT_HOOKS_H

#define AH_AUDAUX_SZ 64

enum hook_names {
	sys_setxattr_nr,
	sys_lsetxattr_nr,
	sys_fsetxattr_nr,
	sys_removexattr_nr,
	sys_lremovexattr_nr,
	sys_fremovexattr_nr,
	sys_chroot_nr,
	do_execve_nr,
	sys_chown_nr,
	sys_lchown_nr,
	sys_fchown_nr,
	sys_mount_nr,
	sys_umount_nr,
	sys_fchownat_nr,
	sys_fchmodat_nr,
	sys_mkdirat_nr,
	sys_mknodat_nr,
	sys_renameat_nr,
	sys_renameat2_nr,
	sys_rename_nr,
	sys_linkat_nr,
	sys_symlinkat_nr,
	do_sys_open_nr,
	do_unlinkat_nr,
	do_rmdir_nr,
	vfs_setxattr_nr,
	vfs_removexattr_nr,
	vfs_create_nr,
	may_open_nr,
	vfs_mkdir_nr,
	vfs_mknod_nr,
	vfs_rmdir_nr,
	vfs_unlink_nr,
	vfs_symlink_nr,
	vfs_link_nr,
	vfs_rename_nr,
	notify_change_nr,
	search_binary_handler_nr,
	file_update_time_nr,
	sys_capset_nr,
	sys_setuid_nr,
	sys_setgid_nr,
	sys_setreuid_nr,
	sys_setregid_nr,
	sys_setresuid_nr,
	sys_setresgid_nr,
	sys_setfsuid_nr,
	sys_setfsgid_nr,
	sys_delete_module_nr,
	sys_finit_module_nr,
	sys_init_module_nr,
	sys_connect_nr,
	sys_bind_nr,
	sys_accept4_nr,
	sock_sendmsg_nr,
	sock_recvmsg_nr,
};

struct audit_module {
        void (*fn_pre)(int name, void *aux, ...);
        void (*fn_post)(int name, void *aux, long rc, ...);
};

extern int mod_register_audit(struct audit_module *ops);
extern int mod_unregister_audit(struct audit_module *ops);

#endif
